<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for create-request-response StructType
 * @subpackage Structs
 */
class Create_request_response extends AbstractStructBase
{
    /**
     * The request_id
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var string[]
     */
    public $request_id;
    /**
     * The artifact
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $artifact;
    /**
     * Constructor method for create-request-response
     * @uses Create_request_response::setRequest_id()
     * @uses Create_request_response::setArtifact()
     * @param string[] $request_id
     * @param string $artifact
     */
    public function __construct(array $request_id = array(), $artifact = null)
    {
        $this
            ->setRequest_id($request_id)
            ->setArtifact($artifact);
    }
    /**
     * Get request_id value
     * @return string[]|null
     */
    public function getRequest_id()
    {
        return $this->{'request-id'};
    }
    /**
     * This method is responsible for validating the values passed to the setRequest_id method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRequest_id method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRequest_idForArrayConstraintsFromSetRequest_id(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $create_request_responseRequest_idItem) {
            // validation for constraint: itemType
            if (!is_string($create_request_responseRequest_idItem)) {
                $invalidValues[] = is_object($create_request_responseRequest_idItem) ? get_class($create_request_responseRequest_idItem) : sprintf('%s(%s)', gettype($create_request_responseRequest_idItem), var_export($create_request_responseRequest_idItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The request_id property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set request_id value
     * @throws \InvalidArgumentException
     * @param string[] $request_id
     * @return \StructType\Create_request_response
     */
    public function setRequest_id(array $request_id = array())
    {
        // validation for constraint: array
        if ('' !== ($request_idArrayErrorMessage = self::validateRequest_idForArrayConstraintsFromSetRequest_id($request_id))) {
            throw new \InvalidArgumentException($request_idArrayErrorMessage, __LINE__);
        }
        $this->request_id = $this->{'request-id'} = $request_id;
        return $this;
    }
    /**
     * Add item to request_id value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\Create_request_response
     */
    public function addToRequest_id($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The request_id property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->request_id[] = $this->{'request-id'}[] = $item;
        return $this;
    }
    /**
     * Get artifact value
     * @return string|null
     */
    public function getArtifact()
    {
        return $this->artifact;
    }
    /**
     * Set artifact value
     * @param string $artifact
     * @return \StructType\Create_request_response
     */
    public function setArtifact($artifact = null)
    {
        // validation for constraint: string
        if (!is_null($artifact) && !is_string($artifact)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($artifact, true), gettype($artifact)), __LINE__);
        }
        $this->artifact = $artifact;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Create_request_response
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
