<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for delete-request-request StructType
 * @subpackage Structs
 */
class Delete_request_request extends AbstractStructBase
{
    /**
     * The service
     * @var string
     */
    public $service;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The request_id
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var string[]
     */
    public $request_id;
    /**
     * Constructor method for delete-request-request
     * @uses Delete_request_request::setService()
     * @uses Delete_request_request::setPassword()
     * @uses Delete_request_request::setRequest_id()
     * @param string $service
     * @param string $password
     * @param string[] $request_id
     */
    public function __construct($service = null, $password = null, array $request_id = array())
    {
        $this
            ->setService($service)
            ->setPassword($password)
            ->setRequest_id($request_id);
    }
    /**
     * Get service value
     * @return string|null
     */
    public function getService()
    {
        return $this->service;
    }
    /**
     * Set service value
     * @param string $service
     * @return \StructType\Delete_request_request
     */
    public function setService($service = null)
    {
        // validation for constraint: string
        if (!is_null($service) && !is_string($service)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($service, true), gettype($service)), __LINE__);
        }
        $this->service = $service;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\Delete_request_request
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get request_id value
     * @return string[]|null
     */
    public function getRequest_id()
    {
        return $this->{'request-id'};
    }
    /**
     * This method is responsible for validating the values passed to the setRequest_id method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRequest_id method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRequest_idForArrayConstraintsFromSetRequest_id(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $delete_request_requestRequest_idItem) {
            // validation for constraint: itemType
            if (!is_string($delete_request_requestRequest_idItem)) {
                $invalidValues[] = is_object($delete_request_requestRequest_idItem) ? get_class($delete_request_requestRequest_idItem) : sprintf('%s(%s)', gettype($delete_request_requestRequest_idItem), var_export($delete_request_requestRequest_idItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The request_id property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set request_id value
     * @throws \InvalidArgumentException
     * @param string[] $request_id
     * @return \StructType\Delete_request_request
     */
    public function setRequest_id(array $request_id = array())
    {
        // validation for constraint: array
        if ('' !== ($request_idArrayErrorMessage = self::validateRequest_idForArrayConstraintsFromSetRequest_id($request_id))) {
            throw new \InvalidArgumentException($request_idArrayErrorMessage, __LINE__);
        }
        $this->request_id = $this->{'request-id'} = $request_id;
        return $this;
    }
    /**
     * Add item to request_id value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\Delete_request_request
     */
    public function addToRequest_id($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The request_id property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->request_id[] = $this->{'request-id'}[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Delete_request_request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
