<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for get-packaging-task-status-response StructType
 * @subpackage Structs
 */
class Get_packaging_task_status_response extends AbstractStructBase
{
    /**
     * The packaging_task_status_info
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Packaging_task_status_info[]
     */
    public $packaging_task_status_info;
    /**
     * Constructor method for get-packaging-task-status-response
     * @uses Get_packaging_task_status_response::setPackaging_task_status_info()
     * @param \StructType\Packaging_task_status_info[] $packaging_task_status_info
     */
    public function __construct(array $packaging_task_status_info = array())
    {
        $this
            ->setPackaging_task_status_info($packaging_task_status_info);
    }
    /**
     * Get packaging_task_status_info value
     * @return \StructType\Packaging_task_status_info[]|null
     */
    public function getPackaging_task_status_info()
    {
        return $this->{'packaging-task-status-info'};
    }
    /**
     * This method is responsible for validating the values passed to the setPackaging_task_status_info method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPackaging_task_status_info method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePackaging_task_status_infoForArrayConstraintsFromSetPackaging_task_status_info(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $get_packaging_task_status_responsePackaging_task_status_infoItem) {
            // validation for constraint: itemType
            if (!$get_packaging_task_status_responsePackaging_task_status_infoItem instanceof \StructType\Packaging_task_status_info) {
                $invalidValues[] = is_object($get_packaging_task_status_responsePackaging_task_status_infoItem) ? get_class($get_packaging_task_status_responsePackaging_task_status_infoItem) : sprintf('%s(%s)', gettype($get_packaging_task_status_responsePackaging_task_status_infoItem), var_export($get_packaging_task_status_responsePackaging_task_status_infoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The packaging_task_status_info property can only contain items of type \StructType\Packaging_task_status_info, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set packaging_task_status_info value
     * @throws \InvalidArgumentException
     * @param \StructType\Packaging_task_status_info[] $packaging_task_status_info
     * @return \StructType\Get_packaging_task_status_response
     */
    public function setPackaging_task_status_info(array $packaging_task_status_info = array())
    {
        // validation for constraint: array
        if ('' !== ($packaging_task_status_infoArrayErrorMessage = self::validatePackaging_task_status_infoForArrayConstraintsFromSetPackaging_task_status_info($packaging_task_status_info))) {
            throw new \InvalidArgumentException($packaging_task_status_infoArrayErrorMessage, __LINE__);
        }
        $this->packaging_task_status_info = $this->{'packaging-task-status-info'} = $packaging_task_status_info;
        return $this;
    }
    /**
     * Add item to packaging_task_status_info value
     * @throws \InvalidArgumentException
     * @param \StructType\Packaging_task_status_info $item
     * @return \StructType\Get_packaging_task_status_response
     */
    public function addToPackaging_task_status_info(\StructType\Packaging_task_status_info $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Packaging_task_status_info) {
            throw new \InvalidArgumentException(sprintf('The packaging_task_status_info property can only contain items of type \StructType\Packaging_task_status_info, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->packaging_task_status_info[] = $this->{'packaging-task-status-info'}[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Get_packaging_task_status_response
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
